package com.tencent.ticsdk.demo;

import android.content.Context;
import android.content.SharedPreferences;

/**
 * Created by eric on 2018/5/16.
 */

public class ClassInfo {
    private final static String TAG = "ClassInfo";

    private final static String KEY_CLASSID = "classId";

    private String classId;
    private boolean roleTeacher = false;
    private boolean qcloud = true;
    private String userid;

    private static final ClassInfo ourInstance = new ClassInfo();

    public static ClassInfo getInstance() {
        return ourInstance;
    }

    private ClassInfo() {
    }

    public String getClassId() {
        return classId;
    }

    public void setClassId(String classId) {
        this.classId = classId;
    }

    public boolean isRoleTeacher() {
        return roleTeacher;
    }

    public void setRoleTeacher(boolean roleTeacher) {
        this.roleTeacher = roleTeacher;
    }

    public boolean isQcloud() {
        return qcloud;
    }

    public void setQcloud(boolean qcloud) {
        this.qcloud = qcloud;
    }

    public String getUserid() {
        return userid;
    }

    public void setUserid(String userid) {
        this.userid = userid;
    }

    public void writeToCache(Context context) {
        SharedPreferences sharedPreferences = context.getSharedPreferences(TAG, 0);
        SharedPreferences.Editor editor = sharedPreferences.edit();
        editor.putString(KEY_CLASSID, classId);
        editor.commit();
    }

    public void resumeFromCache(Context context) {
        SharedPreferences sharedPreferences = context.getSharedPreferences(TAG, 0);
        classId = sharedPreferences.getString(KEY_CLASSID, ConfigInfo.getInstance().getClassId());
    }
}
