package com.tencent.ticsdk.demo.login;

import com.tencent.ilivesdk.ILiveCallBack;
import com.tencent.ticsdk.TICManager;

public class LoginPresenter {
    LoginView loginView;

    public LoginPresenter(LoginView loginView) {
        this.loginView = loginView;
    }

    public void login(String userid, String userSig) {
        TICManager.getInstance().login(userid, userSig, new ILiveCallBack() {
            @Override
            public void onSuccess(Object data) {
                loginView.onLoginSuccess();
            }

            @Override
            public void onError(String module, int errCode, String errMsg) {
                loginView.onLoginError(module, errCode, errMsg);
            }
        });
    }

    public void logout() {
        TICManager.getInstance().logout(new ILiveCallBack() {
            @Override
            public void onSuccess(Object data) {
                loginView.onLogoutSuccess();
            }

            @Override
            public void onError(String module, int errCode, String errMsg) {
                loginView.onLogoutError(module, errCode, errMsg);
            }
        });
    }
}
