package com.tencent.ticsdk.demo.privateMapKey;

import android.util.Log;

import com.tencent.ilivesdk.ILiveCallBack;
import com.tencent.ilivesdk.adapter.ILiveHttpEngine;
import com.tencent.ilivesdk.adapter.normal_impl.NormalHttpCtrl;
import com.tencent.ilivesdk.data.ILiveHttpReq;
import com.tencent.ticsdk.core.Constants;
import com.tencent.ticsdk.core.Error;

import org.json.JSONException;

/**
 * Created by eric on 2018/7/6.
 */

public class PrivateMapKeyDelegate {
    private final static String TAG = "PrivateMapKeyDelegate";

    private static String SERVER_SVR = "https://sxb.qcloud.com/sxb_dev/?svc=account&cmd=authPrivMap";

    private ILiveHttpEngine httpEngine;

    public PrivateMapKeyDelegate() {
        httpEngine = new NormalHttpCtrl();
        httpEngine.init(new HttpConfig());
    }

    public void sendPacket(PrivateMapKeyParams param, ILiveCallBack<String> callBack) {
        ILiveHttpReq req = new ILiveHttpReq()
                .add_header("Content-Type", "application/json");

        if (param == null) {
            Log.i(TAG, "sendPacket: not support param");
            callBack.onError(Constants.MODULE_TIC_SDK, Error.ERR_INVALID_PARAMS, Error.ERR_MSG_INVALID_PARAMS);
            return;
        }
        req.set_url(SERVER_SVR);
        try {
            req.set_data(param.toJsonString().getBytes());
        } catch (Exception e) {
            Log.e(TAG, "sendPacket exception happened:", e);
        }
        httpEngine.asyncPost(req, callBack);
    }
}
