package com.tencent.ticsdk.demo.privateMapKey;

import com.tencent.ilivesdk.ILiveCallBack;

import org.json.JSONException;
import org.json.JSONObject;
import org.json.JSONTokener;

/**
 * Created by eric on 2018/7/6.
 */

public class PrivateMapKeyPresenter {
    PrivateMapKeyView privateMapKeyView;
    PrivateMapKeyDelegate delegate;

    public PrivateMapKeyPresenter(PrivateMapKeyView privateMapKeyView) {
        this.privateMapKeyView = privateMapKeyView;
        delegate = new PrivateMapKeyDelegate();
    }

    public void getPrivateMapKey(PrivateMapKeyParams params) {
        delegate.sendPacket(params, new ILiveCallBack<String>() {
            @Override
            public void onSuccess(String s) {
                try {
                    JSONTokener jsonTokener = new JSONTokener(s);
                    JSONObject msgJson = (JSONObject) jsonTokener.nextValue();
                    int errorCode = msgJson.getInt("errorCode");
                    if (errorCode != 0) {
                        String errorMsg = msgJson.getString("errorInfo");
                        privateMapKeyView.onGetPrivateMapKeyFail("PrivateMapKeyPresenter", errorCode, errorMsg);
                        return;
                    }
                    PrivateMapKeyInfo privateMapKeyInfo = new PrivateMapKeyInfo();
                    privateMapKeyInfo.initFromJson(msgJson.getJSONObject("data"));
                    privateMapKeyView.onGetPrivateMapKeySuccess(privateMapKeyInfo.getPrivMapEncrypt());
                } catch (JSONException e) {
                    privateMapKeyView.onGetPrivateMapKeyFail("PrivateMapKeyPresenter", -1, e.toString());
                }
            }

            @Override
            public void onError(String s, int i, String s1) {
                privateMapKeyView.onGetPrivateMapKeyFail(s, i, s1);
            }
        });
    }
}
