package com.tencent.ticsdk.demo.views;

import android.content.Context;
import android.graphics.Color;
import android.util.AttributeSet;
import android.util.Log;

import com.tencent.av.sdk.AVView;
import com.tencent.ilivesdk.ILiveConstants;
import com.tencent.ilivesdk.view.AVRootView;
import com.tencent.ilivesdk.view.AVVideoView;
import com.tencent.ilivesdk.view.BaseVideoView;
import com.tencent.ilivesdk.view.ILiveRootView;

/**
 * Created by eric on 2018/1/31.
 */

public class LivingVideoView extends AVRootView implements AVRootView.onSubViewCreatedListener {

    private final static String TAG = "LivingVideoView";
    // 小屏宽度
    private int subWidth = 0;

    public LivingVideoView(Context context) {
        super(context);
        initRootView();
    }

    public LivingVideoView(Context context, AttributeSet attributeSet) {
        super(context, attributeSet);
        initRootView();
    }

    private void initRootView() {
        setGravity(AVRootView.LAYOUT_GRAVITY_BOTTOM);
        setSubMarginX(0);
        setSubMarginY(0);
        setSubPadding(1);
        setRoleDt(90);
        getVideoGroup().setBackgroundColor(Color.WHITE);
        super.setSubCreatedListener(this);
    }

    @Override
    protected void onMeasure(int widthMeasureSpec, int heightMeasureSpec) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec);
        int width = MeasureSpec.getSize(widthMeasureSpec);
        int dstHeight = (int) (width * 9.0f / 16.0f);
        super.onMeasure(widthMeasureSpec, MeasureSpec.makeMeasureSpec(dstHeight, MeasureSpec.EXACTLY));
    }

    @Override
    public void onSubViewCreated() {
        Log.i(TAG, "onSubViewCreated");
        subWidth = (getWidth()) / 4;
        for (int i = 0; i < ILiveConstants.MAX_AV_VIDEO_NUM; i++) {
            AVVideoView avVideoView = getViewByIndex(i);
            avVideoView.setDiffDirectionRenderMode(BaseVideoView.BaseRenderMode.SCALE_TO_FIT);
//            if (avVideoView.getVideoSrcType() == AVView.VIDEO_SRC_TYPE_SCREEN) {
//                avVideoView.setPosLeft(0);
//                avVideoView.setPosTop(0);
//                avVideoView.setPosWidth(getWidth());
//                avVideoView.setPosHeight(getHeight());
//            }
            if (0 == i) {
                avVideoView.setPosLeft(0);
                avVideoView.setPosTop(0);
                avVideoView.setPosWidth(getWidth());
                avVideoView.setPosHeight(getHeight());
            } else {
                avVideoView.setPosLeft((subWidth) * (i - 1));
                avVideoView.setPosTop(getHeight() - subWidth);
                avVideoView.setPosWidth(subWidth);
                avVideoView.setPosHeight(subWidth);
            }
            avVideoView.autoLayout();
        }

    }
}
