package com.tencent.ticsdk.demo.widgets;

import android.app.Dialog;
import android.content.Context;
import android.support.annotation.NonNull;
import android.util.Log;
import android.view.Display;
import android.view.WindowManager;
import android.widget.Toast;

/**
 * Created by eric on 2018/5/18.
 */

public class BaseDialog extends Dialog {
    private final String TAG = this.getClass().getSimpleName();
    private Context context;

    public BaseDialog(@NonNull Context context) {
        this(context, 0);
    }

    public BaseDialog(@NonNull Context context, int theme) {
        super(context, theme);
        this.context = context;
        WindowManager windowManager = getWindow().getWindowManager();
        Display display = windowManager.getDefaultDisplay();
        WindowManager.LayoutParams lp = getWindow().getAttributes();

        lp.width = display.getWidth(); //设置宽度
        getWindow().setAttributes(lp);
        setCancelable(true);
        setCanceledOnTouchOutside(true);
    }

    protected void postToast(String msg) {
        Log.i(TAG, msg);
        Toast.makeText(context, msg, Toast.LENGTH_SHORT).show();
    }
}
