package com.tencent.ticsdk.demo.widgets;

import android.content.Context;
import android.support.annotation.NonNull;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;

import com.tencent.ticsdk.demo.ClassInfo;
import com.tencent.ticsdk.demo.R;

/**
 * Created by eric on 2018/5/18.
 */

public class ClassIdInputDialog extends BaseDialog {
    final EditText edit;
    final Button btnOk;

    public ClassIdInputDialog(@NonNull Context context, final ClassIdInputListener classIdInputListener) {
        super(context);
        setContentView(R.layout.dialog_input_classid);

        edit = (EditText) findViewById(R.id.et_classid);

        ClassInfo.getInstance().resumeFromCache(context);
        edit.setText(ClassInfo.getInstance().getClassId());

        btnOk =  (Button) findViewById(R.id.confirm);
        btnOk.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                int id = Integer.valueOf(edit.getText().toString().trim());

                if (classIdInputListener != null){
                    classIdInputListener.onClassInput(id);
                }
                dismiss();
            }
        });
    }



    public interface ClassIdInputListener {
        void onClassInput(int id);
    }
}
