package com.tencent.ticsdk.demo.widgets;

import android.app.Dialog;
import android.content.Context;
import android.view.View;
import android.widget.TextView;

import com.tencent.ticsdk.demo.R;


public class FilePickerDialog extends Dialog implements View.OnClickListener {

    public static final int REQUEST_CAPTURE_IMAGE_CAMERA = 100;
    public static final int REQUEST_IMAGE_STORE = 200;
    public static final int REQUEST_DOCUMENT_STORE = 300;

    TextView tvDocFilePicker, tvFilePicker, tvImagePicker;
    WhiteboardToolBar.FilePickerClickListener listener;

    public FilePickerDialog(Context context, int themeResId, WhiteboardToolBar.FilePickerClickListener pickerListener) {
        super(context, themeResId);
        setContentView(R.layout.whiteboard_file_picker_layout);
        tvDocFilePicker = findViewById(R.id.tv_document);
        tvFilePicker = findViewById(R.id.tv_camera);
        tvImagePicker = findViewById(R.id.tv_image_picker);
        tvDocFilePicker.setOnClickListener(this);
        tvFilePicker.setOnClickListener(this);
        tvImagePicker.setOnClickListener(this);
        listener = pickerListener;
    }

    @Override
    public void onClick(View v) {
        int type = REQUEST_DOCUMENT_STORE;
        switch (v.getId()) {
            case R.id.tv_camera:
                type = REQUEST_CAPTURE_IMAGE_CAMERA;
                break;
            case R.id.tv_image_picker:
                type = REQUEST_IMAGE_STORE;
                break;
        }
        if (listener != null) {
            listener.onFilePickerClick(type);
        }
        this.dismiss();
    }

}
